<template>
  <BasicModal
    v-bind="$attrs"
    destroyOnClose
    @register="registerModal"
    :title="getTitle"
    :width="width"
    @ok="handleSubmit"
    :showFooter="true"
  >
    <div class="!pl-8 !pt-4">
      <BasicForm @register="registerForm" layout="vertical" />
    </div>
  </BasicModal>
</template>
<script lang="ts" setup>
  import { ref, computed, unref } from 'vue';
  import { BasicModal, useModalInner } from '/@/components/Modal';
  import { BasicForm, useForm } from '/@/components/Form';
  import { useMessage } from '/@/hooks/web/useMessage';
  import { dataFormSchema } from './data';
  import {
    archivesMedicalDocumentsAdd,
    archivesMedicalDocumentsEdit,
    archivesMedicalDocumentsDetail,
  } from '/@/api/biz/archives/medicalDocumentsApi';
  import dayjs from 'dayjs';

  const emit = defineEmits(['success', 'register']);

  const getTitle = computed(() => (!unref(isUpdate) ? '新增文书' : '编辑文书'));
  const width = '600px';
  const isUpdate = ref(false);
  const rowId = ref();
  const patientBasicId = ref();

  const { createMessage } = useMessage();
  const [registerForm, { setFieldsValue, resetFields, validate }] = useForm({
    labelWidth: 100,
    schemas: dataFormSchema,
    showActionButtonGroup: false,
    // baseColProps: {
    //   span: 12,
    // },
    wrapperCol: {
      span: 22,
    },
  });
  const [registerModal, { setModalProps, closeModal }] = useModalInner(async data => {
    await resetFields();
    setModalProps({ confirmLoading: false });
    isUpdate.value = data?.isUpdate;
    patientBasicId.value = data.record.patientBasicId;
    if (unref(isUpdate)) {
      const resData = await archivesMedicalDocumentsDetail(data.record.id);
      console.log('🚀 ~ file: FormModal.vue:58 ~ resData:', resData);
      rowId.value = resData.id;
      await setFieldsValue({
        ...resData,
      });
    } else {
      await setFieldsValue({
        updateTime: dayjs().format('YYYY-MM-DD'),
        files: [],
      });
    }
  });

  // 提交按钮事件
  async function handleSubmit() {
    try {
      const values = await validate();
      setModalProps({ confirmLoading: true });
      values.patientBasicId = patientBasicId.value;
      values.fileIds = values.files && values.files.map(ele => ele.id);
      console.log('🚀 ~ file: FormModal.vue:71 ~ handleSubmit ~ values:', {
        ...values,
        id: rowId.value,
      });
      !unref(isUpdate)
        ? await archivesMedicalDocumentsAdd({ ...values })
        : await archivesMedicalDocumentsEdit({ ...values, id: rowId.value });
      !unref(isUpdate) ? createMessage.success('新增成功！') : createMessage.success('编辑成功！');
      closeModal();
      emit('success', {
        isUpdate: unref(isUpdate),
        values: { ...values, id: rowId.value },
      });
    } finally {
      setModalProps({ confirmLoading: false });
    }
  }
</script>
